123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384 |
- #!/bin/sh
- if test "${0##*/}" = "gunzip.tests"; then
- unpack=gunzip
- ext=gz
- elif test "${0##*/}" = "bunzip2.tests"; then
- unpack=bunzip2
- ext=bz2
- else
- echo "WTF? argv0='$0'"
- exit 1
- fi
- bb="busybox "
- unset LC_ALL
- unset LC_MESSAGES
- unset LANG
- unset LANGUAGE
- hello_gz() {
- # Gzipped "HELLO\n"
- #_________________________ vvv vvv vvv vvv - mtime
- echo -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7"
- echo -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00"
- }
- hello_bz2() {
- # Bzipped "HELLO\n"
- echo -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00"
- echo -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97"
- echo -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3"
- }
- prep() {
- rm -f t*
- hello_$ext >t1.$ext
- hello_$ext >t2.$ext
- }
- check() {
- eval $2 >t_actual 2>&1
- if echo -ne "$expected" | cmp - t_actual; then
- echo "$1: PASS"
- else
- echo "$1: FAIL"
- fi
- }
- mkdir testdir 2>/dev/null
- (
- cd testdir || { echo "cannot cd testdir!"; exit 1; }
- expected="$unpack: z: No such file or directory
- 1
- HELLO
- "
- prep; check "$unpack: doesnt exist" "${bb}$unpack z t1.$ext; echo \$?; cat t1"
- expected="$unpack: t.zz: unknown suffix - ignored
- 1
- HELLO
- "
- prep; >t.zz; check "$unpack: unknown suffix" "${bb}$unpack t.zz t1.$ext; echo \$?; cat t1"
- # In this case file "t1" exists, and we skip t1.gz and unpack t2.gz
- expected="$unpack: can't open 't1': File exists
- 1
- HELLO
- "
- prep; >t1; check "$unpack: already exists" "${bb}$unpack t1.$ext t2.$ext; echo \$?; cat t1 t2"
- # From old testsuite
- expected="HELLO\n0\n"
- prep; check "$unpack: stream unpack" "cat t1.$ext | ${bb}$unpack; echo $?"
- expected="ok\n"
- prep; check "$unpack: delete src" "${bb}$unpack t2.$ext; test ! -f t2.$ext && echo ok"
- )
- rm -rf testdir
|